package org.example;

import javax.ejb.Stateless;
import javax.persistence.*;
import java.util.*;

@Stateless
public class DataEJB {
    
  @PersistenceContext EntityManager em;

  public DataEJB() {
  }

  // initData
  public boolean initData() {
    boolean pass= false;

    Customer c1 = customerExample1();
    Customer c2 = customerExample2();
    Customer c3 = customerExample3();
    try {
      em.persist(c1);
      em.persist(c2);
      em.persist(c3);
      em.flush();
      pass = true;
    } catch(Throwable e){
      e.printStackTrace();
    }
    return pass;
  }

  public boolean  queryByCity() {
      boolean pass= false;
      int n = 0;
      String cityName ="Ottawa";
      Query q = em.createNamedQuery("findCustomerByCity");
      q.setParameter("city", cityName);
      List<Customer> results = (List<Customer>) q.getResultList();
      n = results.size();
      if ( n == 2) 
	pass = true;
      System.out.println("========jpa:queryByCity n="+n);
      return pass;
 } 

  public boolean  queryById() {
      boolean pass= false;
      int n = 0;
      int customerId = 1;
      Query q = em.createNamedQuery("findCustomerById");
      q.setParameter("id", customerId);
      List<Customer> results = (List<Customer>) q.getResultList();
      n = results.size();
      if ( n == 1) 
	pass = true;
      System.out.println("========jpa:queryById n="+n);
      return pass;
 } 

  public Address addressExample1() {
    Address address = new Address();
    address.setId(1);
    address.setStreet("1 A Street");
    address.setCity("Ottawa");
    return address;
  }

  public Address addressExample2() {
    Address address = new Address();
    address.setId(2);
    address.setStreet("1111 Moose Rd.");
    address.setCity("Calgary");
    return address;
  }

  public Address addressExample3() {
    Address address = new Address();
    address.setId(3);
    address.setStreet("1 Nowhere Drive");
    address.setCity("Ottawa");
    return address;
  }

  public Customer customerExample1() {
    Customer customer = new Customer();
    try {
      customer.setId(1);
      customer.setFirstName("Jane");
      customer.setLastName("Doe");
      customer.setAddress(addressExample1());
      /* error in get
javax.ws.rs.WebApplicationException: 
  javax.xml.bind.MarshalException
 - with linked exception:
[com.sun.istack.SAXException2: 
 A cycle is detected in the object graph. 
 This will cause infinitely deep XML: org.example.Customer@5c6e55 -> org.example.PhoneNumber@a7eb3f -> org.example.Customer@5c6e55]

      List<PhoneNumber> phoneNumbers = new ArrayList<PhoneNumber>(2);
      PhoneNumber workPhone = new PhoneNumber();
      workPhone.setId(1);
      workPhone.setNum("555-1111");
      workPhone.setType("WORK");
      workPhone.setCustomer(customer);
      phoneNumbers.add(workPhone);

      PhoneNumber homePhone = new PhoneNumber();
      homePhone.setId(2);
      homePhone.setNum("555-2222");
      homePhone.setType("HOME");
      homePhone.setCustomer(customer);
      phoneNumbers.add(homePhone);

      customer.setPhoneNumbers(phoneNumbers);
      */
    } catch (Exception exception) {
      throw new RuntimeException(exception.toString());
    }

    return customer;
  }

  public Customer customerExample2() {
    Customer customer = new Customer();

    try {
      customer.setId(2);
      customer.setFirstName("Jill");
      customer.setLastName("May");
      customer.setAddress(addressExample2());
      /*
      List<PhoneNumber> phoneNumbers = new ArrayList<PhoneNumber>(2);
      PhoneNumber workPhone = new PhoneNumber();
      workPhone.setId(3);
      workPhone.setNum("555-3333");
      workPhone.setType("WORK");
      workPhone.setCustomer(customer);
      phoneNumbers.add(workPhone);
      PhoneNumber homePhone = new PhoneNumber();
      homePhone.setId(4);
      homePhone.setNum("555-4444");
      homePhone.setType("HOME");
      homePhone.setCustomer(customer);
      phoneNumbers.add(homePhone);

      customer.setPhoneNumbers(phoneNumbers);
      */
    } catch (Exception exception) {
      throw new RuntimeException(exception.toString());
    }

    return customer;
  }

  public Customer customerExample3() {
    Customer customer = new Customer();

    try {
      customer.setId(3);
      customer.setFirstName("Sarah-loo");
      customer.setLastName("Smitty");
      customer.setAddress(addressExample3());
      /*
      List<PhoneNumber> phoneNumbers = new ArrayList<PhoneNumber>(2);
      PhoneNumber workPhone = new PhoneNumber();
      workPhone.setId(5);
      workPhone.setNum("555-5555");
      workPhone.setType("WORK");
      workPhone.setCustomer(customer);
      phoneNumbers.add(workPhone);
      PhoneNumber homePhone = new PhoneNumber();
      homePhone.setId(6);
      homePhone.setNum("555-6666");
      homePhone.setType("HOME");
      homePhone.setCustomer(customer);
      phoneNumbers.add(homePhone);

      customer.setPhoneNumbers(phoneNumbers);
      */
    } catch (Exception exception) {
      throw new RuntimeException(exception.toString());
    }

    return customer;
  }

}




