package org.example;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

@WebServlet(name="DataServlet", urlPatterns={"/data/*"})
public class DataServlet extends HttpServlet {

    @EJB
    private DataEJB dataEJB;

    protected void processRequest(HttpServletRequest request,
                                  HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        boolean status = false;
        String testcase = null;
        try {
            out.println("DataServlet at " + request.getContextPath());
            testcase = request.getParameter("tc");
	    // System.out.println("dataEJB = " + dataEJB);
            if ("initData".equals(testcase)) {

                status = dataEJB.initData();

            } else if ("queryByCity".equals(testcase)) {

                status = dataEJB.queryByCity();

            } else if ("queryById".equals(testcase)) {

                status = dataEJB.queryById();

            } else {
                System.out.println("Invalid test case: " + testcase);
                out.println("Invalid test case: " + testcase);
	    }
	    // System.out.println("status = " + status);
        } catch (Exception ex) {

            System.out.println("Failure in DataServlet");
	    out.println("Failure in DataServlet");

        } finally {

            if (status) 
              out.println(testcase+":pass");
            else
              out.println(testcase+":fail");
            out.close();
        }
    }

    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }


    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    public String getServletInfo() {
        return "DataServlet";
    }

}
